#!/usr/bin/php
<?
chdir(dirname(__FILE__));
require_once('../nmail/include/global.php');
require_once("include/mail_lib.php");
require_once("include/admin_lib.php");
require_once("include/file.php");


// 웹상에서의 실행방지.
if ($_SERVER['DOCUMENT_ROOT'] || $_SERVER['SERVER_SOFTWARE'])
{
	die("Access Denied");
}	// if()


echo "[Nmail] 메일 사용량 갱신 작업.\n\n";
echo "-. nmail_member_size 테이블의 ms_mail 컬럼에 현재 메일 사용량을 기록합니다.\n";


// [2007-04-03] 중복실행방지
	$pname = basename(__FILE__);
	$pname2 = preg_replace('/\.php$/i', "", $pname);

	$pid = $pname2.'.pid';
	// 파일이 있을 경우 먼저 실행중인 스크립트가 존재하는지 확인함.
	if (file_exists($pid))
	{
		list($pid_old) = file($pid);
		if (is_numeric($pid_old))
		{
			ob_start();
			system('ps -fp '.$pid_old);
			$ps = ob_get_contents();
			ob_end_clean();
			if (strpos($ps, $pname) !== false)
			{
				echo "\n[경고]메일 사용량 갱신 작업이 이미 진행중이므로 중단합니다.\n\n";
				echo $ps;
				echo "\n";
				exit;
			}	// if()
		}	// if()
	}	// if()

	// pid
	$fh=fopen($pname2.'.pid',"w");
	fwrite($fh,getmypid());
	fclose($fh);


// set
set_time_limit(0);
ini_set('memory_limit', '512M');
$memory_limit = ini_get('memory_limit');
#echo "memory_get_usage: ".number_format(memory_get_usage()) . "\n";

$_start = getmicrotime();

// 입력값 확인.
$d_name_input = addslashes($_SERVER['argv'][1]);
$m_id_input = addslashes($_SERVER['argv'][2]);
#if (!$d_name_input || !$m_id_input)
if (!$d_name_input)
{
	die("  사용방법)\n    - 특정 회  원 : ".$_SERVER['PHP_SELF']." domain.com userid\n    - 특정 도메인 : ".$_SERVER['PHP_SELF']." domain.com\n    - 전체 도메인 : ".$_SERVER['PHP_SELF']." ALL\n");
}	// if()


if ($d_name_input == 'ALL')
{
	$dm = db_get_rows("SELECT d_no, d_name FROM " . $TB['DOMAIN'] . "");
} else
{
	$d_no = db_get_one("SELECT d_no FROM " . $TB['DOMAIN'] . " WHERE d_name = '" . $d_name_input . "'");
	if (!$d_no)
		die("존재하지 않는 도메인입니다.\n=> " . $d_name_input."\n");

	$q_where = '';
	if ($m_id_input)
	{
		$q_where = " m_id = '" . $m_id_input . "' AND ";
	}	// if()

	$dm = array(array('d_no'=>$d_no, 'd_name'=>$d_name_input));
}	// if()

for ($di=0; $di<sizeof($dm); $di++)
{

	$d_no = $dm[$di]['d_no'];
	$d_name = $dm[$di]['d_name'];

	// [2007-07-21] 메일링 리스트 계정은 제외
	//$mbr = db_get_rows("SELECT m_no, m_id, m_mail_file_group FROM " . $TB['MEMBER'] . " WHERE ".$q_where." d_no = '" . $d_no . "'");
	$mbr = db_get_rows("SELECT * FROM " . $TB['MEMBER'] . " WHERE ".$q_where." d_no = '" . $d_no . "' AND m_usertype IS NULL");
	$mbr_cnt = sizeof($mbr);
	if ($mbr_cnt < 1)
	{
		if ($m_id_input)
		{
			die("존재하지 않는 사용자입니다.\n=> " . $m_id_input."\n");
		} else if ($d_name_input != 'ALL')
		{
			die("도메인내에 등록된 사용자가 없습니다.\n");
		}	// if()
	} else
	{
		echo "[".$d_name."] ".number_format($mbr_cnt)."명의 메일 사용량 갱신 작업을 시작합니다.\n";

		for ($mi=0; $mi<$mbr_cnt; $mi++)
		{
            // [2023-04-07] 메일 사용량 갱신
			// m_quota
			$mail_file_table = $G_SYS['PRE_FIX'] . 'mail_file_' . $mbr[$mi]['d_no'] . '_' . $mbr[$mi]['m_mail_file_group'];
			$q_hint = ($G_SYS['DB'] == 'oracle') ? "/*+ ORDERED index_asc (".$mail_file_table." MF_".$mbr[$mi]['d_no']."_".$mbr[$mi]['m_mail_file_group']."_MNO_MBID) */" : "";
			$sql = "SELECT ".$q_hint." SUM(mf_filesize) FROM " . $mail_file_table . " WHERE m_no='" . $mbr[$mi]['m_no'] . "'";
			$_mf_filesize_sum = db_get_one($sql);


			$ms_mail = db_get_one("SELECT ms_mail FROM ".$TB['MEMBER_SIZE']." WHERE m_no='".$mbr[$mi]['m_no']."'");

            if ($_mf_filesize_sum !== $ms_mail) {       // 사용량이 디비에 저장된 값과 다를 경우 갱신/추가
	            if ($ms_mail !== null) {
		            $sql = "
                    UPDATE
                        " . $TB['MEMBER_SIZE'] . "
                    SET
                        ms_mail = '" . $_mf_filesize_sum . "'
                    WHERE
                        m_no = '" . $mbr[$mi]['m_no'] . "'
                    ";
		            db_query($sql);
	            } else {
		            $sql = "
                    INSERT INTO
                        " . $TB['MEMBER_SIZE'] . "
                        ( m_no, ms_mail, ms_webhard, ms_bigfile )
                    VALUES
                        ( '" . $mbr[$mi]['m_no'] . "', '" . $_mf_filesize_sum . "', 0, 0 )
                    ";
		            db_query($sql);
	            }    // if()
            }

			// view
			if (($mi > 0 && ($mi+1)%100 == 0) || ($mi+1) == $mbr_cnt)
			{
				echo "... " . number_format($mi+1) . "명 ( " . round(getmicrotime() - $_start) . "sec )\n";
				flush();
			} else if ($mi%10 == 0)
			{
				echo ".";
				flush();
			}	// if()

			if ($mi%10 == 0)
				usleep(100000);

			#echo "[".$d_name."][".$mbr[$mi]['m_id']."]update (" . round((getmicrotime() - $_start),4) . "sec)\n";
		}	// for()

		#echo "[".$d_name."] ".number_format($mbr_cnt)."명의 동기화 작업이 완료되었습니다. (" . round((getmicrotime() - $_start),4) . "sec)\n";
		#echo "[" . round((getmicrotime() - $_start),4) . "sec]동기화 작업이 완료되었습니다.\n";
	}	// if()
}	// for()


// [2007-04-03] 중복실행방지
unlink($pid);

echo "[" . round((getmicrotime() - $_start),4) . "sec]모든 메일 사용량 갱신 작업이 완료되었습니다.\n";

if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
{
	system('pause');
}	// if()

#require_once('include/global_end.php');
?>